#include <SoftwareSerial.h>
#include <Wire.h>
#include <OneWire.h>
#include <LiquidCrystal_I2C.h>
#include <SFE_BMP180.h>
byte _d18x2x1Addr[8]={0x28, 0x61, 0x64, 0x11, 0x95, 0x98, 0x78, 0xC1}; //Датчик Колонны
byte _d18x2x2Addr[8]={0x28, 0xFF, 0xF, 0x3D, 0x32, 0x17, 0x3, 0x3}; //Датчик Куба
byte _d18x2x3Addr[8]={0x28, 0xFF, 0xC6, 0xE3, 0x71, 0x16, 0x3, 0xD7}; //Датчик Аварии
SoftwareSerial Serial100(12, 11);
LiquidCrystal_I2C _lcd1(0x27, 16, 2);
int _dispTempLength1=0;
boolean _isNeedClearDisp1;
SFE_BMP180  _bmp085;
long _bmp085P = 0;
struct UB_185384122
{
    float ubo_120270494 = 0.00;
    bool ubo_13416262 = 0;
    float _gtv1 = 1.00;
    float _gtv2 = 105.00;
}
;
UB_185384122 UB_185384122_Instance1;
UB_185384122 UB_185384122_Instance2;
UB_185384122 UB_185384122_Instance3;
float UB_185384122_ubi_117131038 = 0.00;
OneWire  _ow2(2);
int _AvlDFU0 = 0;
int _AvlDFU100 = 0;
bool _FreeLog2_IArr[2];
bool _FreeLog2_Q1_StArr[] = {0, 1};
int _PWDC = 0;
bool _gtv1 = 1;
float _gtv6 = 777;
float _gtv7 = 777;
bool _gtv12 = 0;
int _gtv2 = 0;
bool _gtv3 = 0;
bool _gtv4 = 0;
float _gtv8 = 110;
float _gtv9;
String _gtv13;
float _gtv14;
float _gtv15;
float _gtv17 = 760;
float _gtv18;
bool _gtv20 = 1;
float _gtv19 = 75; //Температура отключения разгона/включения периферии
float _gtv21 = 65; //Температура срабатывания датчика пара
float _gtv22 = 0; //Коррекция температуры датчика Куба (С)
bool _gtv23 = 1; //Коррекция температуры Старт-Стоп по изменению атмосферного давления (вкл-1, откл-0)
int _gtv27 = 30000; //Задержка перед аварийным отключением (не больше 32000мс)
int _gtv28 = 15000; //Задержка отключения разгона (мс)
bool _gtv24 = 1;
float _gtv26 = 0;
bool _gtv25 = 0;
bool _gtv5 = 1;
bool _gtv31 = 1;
bool _gtv29 = 0;
bool _gtv30 = 0;
bool _gtv32 = 1;
bool _gtv33 = 0;
String _gtv11;
String _gtv10;
String _gtv16;
bool _tim1I = 0;
bool _tim1O = 0;
unsigned long _tim1P = 0UL;
int _FSFS4IO = 0;
int _FSFS5IO = 0;
bool _FSFS5CO = 0;
unsigned long _d18x2x2Tti = 0UL;
float _d18x2x2O = 0.00;
unsigned long _bmp0851Tti = 0UL;
String _GSFS9 = "0";
String _GSFS7 = "0";
bool _gen1I = 0;
bool _gen1O = 0;
unsigned long _gen1P = 0UL;
bool _swi1;
String _GSFS10 = "0";
String _GSFS8 = "0";
int _FSFS2IO = 0;
bool _pzs1OES = 0;
String _swi2;
String _swi7;
unsigned long _d18x2x3Tti = 0UL;
float _d18x2x3O = 0.00;
bool _changeNumber6_Out = 0;
float _changeNumber6_OLV;
bool _changeNumber8_Out = 0;
int _changeNumber8_OLV;
unsigned long _stou1 = 0UL;
int _disp3oldLength = 0;
unsigned long _stou2 = 0UL;
int _FSFS6IO = 0;
String _GSFS2 = "0";
String _GSFS3 = "0";
String _RVFU1Data;
bool _RVFU1Reset = 1;
bool _swi5;
bool _BitChange_4_OldSt = 0;
bool _BitChange_4_Out = 0;
bool _trgr2 = 0;
String _GSFS4 = "0";
bool _tim2I = 0;
bool _tim2O = 0;
unsigned long _tim2P = 0UL;
bool _FreeLog2_Q1 = 0;
bool _swi11;
String _swi3;
int _FSFS9IO = 0;
bool _FSFS9CO = 0;
bool _tim5I = 0;
bool _tim5O = 0;
unsigned long _tim5P = 0UL;
String _GSFS12 = "0";
bool _tim4I = 0;
bool _tim4O = 0;
unsigned long _tim4P = 0UL;
bool _gen3I = 0;
bool _gen3O = 0;
unsigned long _gen3P = 0UL;
bool _trgr3 = 0;
String _swi4;
int _FSFS3IO = 0;
bool _FSFS3CO = 0;
String _GSFS5 = "0";
bool _D1B1 = 0;
int _FSFS10IO = 0;
bool _FSFS10CO = 0;
bool _BitChange_5_OldSt = 0;
bool _BitChange_5_Out = 0;
bool _trgs3 = 0;
bool _changeNumber7_Out = 0;
float _changeNumber7_OLV;
bool _tim3I = 0;
bool _tim3O = 0;
unsigned long _tim3P = 0UL;
String _swi13;
String _GSFS6 = "0";
int _FSFS1IO = 0;
bool _FSFS1CO = 0;
int _disp1oldLength = 0;
String _GSFS13 = "0";
String _RVFU3Data;
bool _RVFU3Reset = 1;
bool _BitChange_1_OldSt = 0;
bool _BitChange_1_Out = 0;
bool _changeNumber5_Out = 0;
float _changeNumber5_OLV;
bool _changeNumber1_Out = 0;
float _changeNumber1_OLV;
bool _changeNumber3_Out = 0;
float _changeNumber3_OLV;
int _FSFS7IO = 0;
bool _FSFS7CO = 0;
bool _tim7I = 0;
bool _tim7O = 0;
unsigned long _tim7P = 0UL;
String _GSFS1 = "0";
String _swi6;
bool _trgs2 = 0;
bool _tim6I = 0;
bool _tim6O = 0;
unsigned long _tim6P = 0UL;
unsigned long _d18x2x1Tti = 0UL;
float _d18x2x1O = 0.00;
String _swi14;
byte _tempVariable_byte;
int _tempVariable_int;
float _tempVariable_float;
void setup()
{
    pinMode(9, INPUT_PULLUP);
    pinMode(7, OUTPUT);
    digitalWrite(7, 0);
    pinMode(8, OUTPUT);
    digitalWrite(8, 0);
    pinMode(15, OUTPUT);
    digitalWrite(15, 0);
    pinMode(14, OUTPUT);
    digitalWrite(14, 0);
    Wire.begin();
    delay(10);
    TCCR2A = 0x00;
    TCCR2B =  0x07;
    TIMSK2=0x01;
    TCNT2=100;
    analogReference(EXTERNAL);
    _bmp085.begin();
    Serial100.begin(9600);
    Serial.begin(115200, SERIAL_8N1);
    _lcd1.init();
    _lcd1.noBacklight();
    _stou1 = millis();
    _stou2 = millis();
}
void loop()
{
    if (_isNeedClearDisp1) 
    {
        _lcd1.clear();
        _isNeedClearDisp1= 0;
    }
    _PWDC = 0;
    if (_AvlDFU0)
    {
        _AvlDFU0=0;
    }
     else
    {
        if (Serial.available()) 
        {
            _AvlDFU0=1;
            _readByteFromUART((Serial.read()),0);
        }
    }
    if (_AvlDFU100)
    {
        _AvlDFU100=0;
    }
     else
    {
        if (Serial100.available()) 
        {
            _AvlDFU100=1;
            _readByteFromUART((Serial100.read()),100);
        }
    }
    if(_isTimer(_bmp0851Tti, 5000)) 
    {
        _bmp0851Tti = millis();
        double _tempBMP085TData;
        _tempVariable_byte = _bmp085.startTemperature();
        if (_tempVariable_byte != 0) 
        {
            delay(_tempVariable_byte);
            _tempVariable_byte = _bmp085.getTemperature(_tempBMP085TData);
            if (_tempVariable_byte != 0) 
            {
                double _tempBMP085PData;
                _tempVariable_byte = _bmp085.startPressure(3);
                if (_tempVariable_byte != 0) 
                {
                    delay(_tempVariable_byte);
                    _tempVariable_byte = _bmp085.getPressure(_tempBMP085PData, _tempBMP085TData);
                    if (_tempVariable_byte != 0) 
                    {
                        _bmp085P =  _tempBMP085PData*100;
                    }
                }
            }
        }
    }
    if (_gtv1)
    {
        if(!_RVFU3Reset)
        {
            _RVFU3Data = String("");
            _RVFU3Reset =1;
        }
    }
     else 
    {
        _RVFU3Reset =0;
    }
    if (_gtv1)
    {
        if(!_RVFU1Reset)
        {
            _RVFU1Data = String("");
            _RVFU1Reset =1;
        }
    }
     else 
    {
        _RVFU1Reset =0;
    }
    if (((_AvlDFU100) || (_AvlDFU0))) 
    {
        _gtv5 = 1;
    }
    _gtv32 = ((_AvlDFU100) || (_AvlDFU0));
    if(((_AvlDFU100) || (_AvlDFU0))) 
    {
        _tim2O = 1;
        _tim2I = 1;
    }
     else 
    {
         if(_tim2I) 
        {
            _tim2I = 0;
            _tim2P = millis();
        }
         else 
        {
             if (_tim2O) 
            {
                if (_isTimer(_tim2P, 1000)) _tim2O = 0;
            }
        }
    }
    _gtv1 = !(_tim2O);
    if(_AvlDFU0) _trgs2 = 1;
    if(_AvlDFU100) _trgs2 = 0;
    if(_trgs2)
    {
        _swi6=_RVFU3Data;
    }
    else
    {
        _swi6=_RVFU1Data;
    }
    _gtv13 = _swi6;
    if (_gtv32 == 1) 
    {
        _FSFS4IO = ((_gtv13).indexOf(String("!")));
        _FSFS3IO = ((_gtv13).indexOf(String("#")));
        _FSFS3CO = _FSFS3IO >-1 ;
        _GSFS5 = (_gtv13).substring((_FSFS3IO), (_FSFS4IO));
        _GSFS6 = (_GSFS5).substring(1);
        if (_FSFS3CO) 
        {
            _gtv2 = (int((_stringToFloat(_GSFS6))));
        }
        _FSFS6IO = ((_gtv13).indexOf(String("!")));
        _FSFS5IO = ((_gtv13).indexOf(String("@")));
        _FSFS5CO = _FSFS5IO >-1 ;
        _GSFS7 = (_gtv13).substring((_FSFS5IO), (_FSFS6IO));
        _GSFS8 = (_GSFS7).substring(1);
        if (_FSFS5CO) 
        {
            _gtv8 = (int((_stringToFloat(_GSFS8))));
        }
        _FSFS2IO = ((_gtv13).indexOf(String("%")));
        _FSFS1IO = ((_gtv13).indexOf(String("*")));
        _FSFS1CO = _FSFS1IO >-1 ;
        if (_FSFS1CO) 
        {
            _gtv18 = _gtv17;
        }
        _GSFS1 = (_gtv13).substring((_FSFS1IO), (_FSFS2IO));
        _GSFS4 = (_GSFS1).substring(1);
        if (_FSFS1CO) 
        {
            _gtv7 = (_stringToFloat(_GSFS4));
        }
        _FSFS10IO = ((_gtv13).indexOf(String("&")));
        _FSFS10CO = _FSFS10IO >-1 ;
        _GSFS13 = (_gtv13).substring((_FSFS10IO), (_FSFS1IO));
        _GSFS3 = (_GSFS13).substring(1);
        if (_FSFS10CO) 
        {
            _gtv6 = (_stringToFloat(_GSFS3));
        }
        _FSFS9IO = ((_gtv13).indexOf(String("$")));
        _FSFS9CO = _FSFS9IO >-1 ;
        _GSFS12 = (_gtv13).substring((_FSFS9IO), (_FSFS10IO));
        _GSFS2 = (_GSFS12).substring(1);
        if(((String("0")).equals(_GSFS2))) _trgr3 = 0;
        if(((String("1")).equals(_GSFS2))) _trgr3 = 1;
        if (_FSFS9CO) 
        {
            _gtv33 = _trgr3;
        }
        _FSFS7IO = ((_gtv13).indexOf(String("^")));
        _FSFS7CO = _FSFS7IO >-1 ;
        _GSFS9 = (_gtv13).substring((_FSFS7IO), (_FSFS9IO));
        _GSFS10 = (_GSFS9).substring(1);
        if(((String("0")).equals(_GSFS10))) _trgr2 = 0;
        if(((String("1")).equals(_GSFS10))) _trgr2 = 1;
        if (_FSFS7CO) 
        {
            _gtv29 = _trgr2;
        }
        _gtv32 = 0;
    }
    if(_isTimer(_d18x2x1Tti, 5000)) 
    {
        _d18x2x1Tti = millis();
        _tempVariable_float =  _readDS18_ow2(_d18x2x1Addr, 0);
        if (_tempVariable_float < 500) 
        {
            _d18x2x1O = _tempVariable_float;
        }
    }
    UB_185384122_ubi_117131038 = (_d18x2x1O);
    _func_UB_185384122(&UB_185384122_Instance1, UB_185384122_ubi_117131038);
    if (((UB_185384122_Instance1.ubo_13416262) && (!(((_d18x2x1O)) == (85))))) 
    {
        _gtv9 = UB_185384122_Instance1.ubo_120270494;
    }
    if (_changeNumber7_Out) 
    {
        _changeNumber7_Out = 0;
    }
     else 
    {
        _tempVariable_float = _gtv9;
        if (_tempVariable_float != _changeNumber7_OLV) 
        {
            _changeNumber7_OLV = _tempVariable_float;
            _changeNumber7_Out = 1;
        }
    }
    if (_changeNumber5_Out) 
    {
        _changeNumber5_Out = 0;
    }
     else 
    {
        _tempVariable_float = _gtv17;
        if (_tempVariable_float != _changeNumber5_OLV) 
        {
            _changeNumber5_OLV = _tempVariable_float;
            _changeNumber5_Out = 1;
        }
    }
    if (_changeNumber1_Out) 
    {
        _changeNumber1_Out = 0;
    }
     else 
    {
        _tempVariable_float = _gtv14;
        if (_tempVariable_float != _changeNumber1_OLV) 
        {
            _changeNumber1_OLV = _tempVariable_float;
            _changeNumber1_Out = 1;
        }
    }
    if (((((_changeNumber7_Out) || (_changeNumber5_Out))) || (_changeNumber1_Out))) 
    {
        _gtv5 = 1;
    }
    if(_isTimer(_d18x2x2Tti, 5000)) 
    {
        _d18x2x2Tti = millis();
        _tempVariable_float =  _readDS18_ow2(_d18x2x2Addr, 0);
        if (_tempVariable_float < 500) 
        {
            _d18x2x2O = _tempVariable_float;
        }
    }
    UB_185384122_ubi_117131038 = (_d18x2x2O);
    _func_UB_185384122(&UB_185384122_Instance2, UB_185384122_ubi_117131038);
    if (((UB_185384122_Instance2.ubo_13416262) && (!(((_d18x2x2O)) == (85))))) 
    {
        _gtv14 = (_gtv22)+(UB_185384122_Instance2.ubo_120270494);
    }
    if(_isTimer(_d18x2x3Tti, 5000)) 
    {
        _d18x2x3Tti = millis();
        _tempVariable_float =  _readDS18_ow2(_d18x2x3Addr, 0);
        if (_tempVariable_float < 500) 
        {
            _d18x2x3O = _tempVariable_float;
        }
    }
    UB_185384122_ubi_117131038 = (_d18x2x3O);
    _func_UB_185384122(&UB_185384122_Instance3, UB_185384122_ubi_117131038);
    if (((UB_185384122_Instance3.ubo_13416262) && (!(((_d18x2x3O)) == (85))))) 
    {
        _gtv15 = UB_185384122_Instance3.ubo_120270494;
    }
    _gtv17 = (_bmp085P)/(133.3);
    if (_gtv5 == 1) 
    {
        _gtv16 = (_floatToStringWitRaz((((_stringToFloat((_floatToStringWitRaz(_gtv14,1)))))+(3.14))*(((_stringToFloat((_floatToStringWitRaz(_gtv9,1)))))+((_stringToFloat((_floatToStringWitRaz(_gtv17,1)))))),1));
        _gtv10 = ((String("HomeSamogon.ru/4.8,")) + ((_floatToStringWitRaz(_gtv9,1))) + (String(",")) + ((_floatToStringWitRaz(_gtv17,1))) + (String(",")) + ((_floatToStringWitRaz(_gtv14,1))) + (String(",")));
    }
    if(_gtv12)
    {
        _swi14=String("1");
    }
    else
    {
        _swi14=String("0");
    }
    if(_gtv33)
    {
        _swi13=String("1");
    }
    else
    {
        _swi13=String("0");
    }
    _gtv25 = ((!((digitalRead (9)))) || ((_gtv15) > (_gtv21)));
    if(((!((digitalRead (9)))) || ((_gtv15) > (_gtv21))))
    {
        _swi3=String("1");
    }
    else
    {
        _swi3=String("0");
    }
    if(_gtv30)
    {
        _swi4=String("1");
    }
    else
    {
        _swi4=String("0");
    }
    if (_gtv1)
    {
         if (_isTimer(_stou1, 2000)) 
        {
            Serial100.print(((_gtv10) + (_swi13) + (String(",")) + (_swi14) + (String(",")) + ((_floatToStringWitRaz((_gtv6)-(_gtv26),1))) + (String(",")) + ((_floatToStringWitRaz((_gtv7)-(_gtv26),1))) + (String(",")) + ((String(_gtv2, DEC))) + (String(",")) + ((_floatToStringWitRaz(_gtv8,2))) + (String(",")) + (_gtv16) + (String(",")) + ((_floatToStringWitRaz(_gtv15,1))) + (String(",")) + (_swi3) + (String(",")) + (_swi4) + (String(",%,"))));
            _stou1 = millis();
        }
    }
     else 
    {
        _stou1 = millis();
    }
    if (_gtv1)
    {
         if (_isTimer(_stou2, 2000)) 
        {
            Serial.print(((_gtv10) + (_swi13) + (String(",")) + (_swi14) + (String(",")) + ((_floatToStringWitRaz((_gtv6)-(_gtv26),1))) + (String(",")) + ((_floatToStringWitRaz((_gtv7)-(_gtv26),1))) + (String(",")) + ((String(_gtv2, DEC))) + (String(",")) + ((_floatToStringWitRaz(_gtv8,2))) + (String(",")) + (_gtv16) + (String(",")) + ((_floatToStringWitRaz(_gtv15,1))) + (String(",")) + (_swi3) + (String(",")) + (_swi4) + (String(",%,"))));
            _stou2 = millis();
        }
    }
     else 
    {
        _stou2 = millis();
    }
    if (_gtv23 == 1) 
    {
        if (_changeNumber3_Out) 
        {
            _changeNumber3_Out = 0;
        }
         else 
        {
            _tempVariable_float = _gtv17;
            if (_tempVariable_float != _changeNumber3_OLV) 
            {
                _changeNumber3_OLV = _tempVariable_float;
                _changeNumber3_Out = 1;
            }
        }
        if (_changeNumber3_Out) 
        {
            _gtv26 = ((_gtv18)-(_gtv17))*(0.035);
        }
    }
    _FreeLog2_IArr[0] = (_gtv2) < (50);
    _FreeLog2_IArr[1] = (_gtv2) >= (972);
    _FreeLog2_Q1 = _checkFreeLogicBlockOutput(_FreeLog2_IArr, 2, _FreeLog2_Q1_StArr, 2);
    if (!((((_gtv2) < (50)) || ((_gtv2) >= (972))))) 
    {
        if (! _gen3I) 
        {
            _gen3I = 1;
            _gen3O = 1;
            _gen3P =  millis();
        }
    }
     else 
    {
        _gen3I = 0 ;
        _gen3O= 0;
    }
     if (_gen3I) 
    {
         if (_gen3O) 
        {
             if (_isTimer(_gen3P , (map((_gtv2), (50), (972), (0), (8000))))) 
            {
                 _gen3P = millis();
                _gen3O = 0;
            }
        }
         else  
        {
             if (_isTimer(_gen3P , (8000)-((map((_gtv2), (50), (972), (0), (8000)))))) 
            {
                  _gen3P = millis();
                _gen3O = 1;
            }
        }
    }
    if((((_gtv2) < (50)) || ((_gtv2) >= (972))))
    {
        _swi5=_FreeLog2_Q1;
    }
    else
    {
        _swi5=_gen3O;
    }
    _gtv3 = _swi5;
    _gtv4 = (((_gtv2) < (50)) || ((_gtv2) >= (972)));
    if(_BitChange_5_Out) 
    {
        _BitChange_5_Out = 0;
    }
    else
    {
        if(!(_BitChange_5_OldSt == _gtv12))
        {
            _BitChange_5_OldSt = _gtv12;
            _BitChange_5_Out= 1;
        }
    }
    if (_BitChange_5_Out) 
    {
        _gtv2 = (map((_gtv2), (0), ((_gtv2)), (0), (((_gtv2)-((_gtv2)/(20))))));
    }
    if((_gtv9) >= ((_gtv7)-((_gtv7)-(_gtv6)))) _trgs3 = 1;
    if((_gtv9) <= (_gtv7)) _trgs3 = 0;
    if (_trgs3)
    {
         if (_tim4I) 
        {
             if (_isTimer(_tim4P, 5000)) 
            {
                _tim4O = 1;
            }
        }
         else 
        {
            _tim4I =1;
            _tim4P = millis();
        }
    }
     else 
    {
        _tim4O = 0;
        _tim4I = 0;
    }
    _gtv12 = !(_tim4O);
    if(_gtv4)
    {
        _swi1=_gtv3;
    }
    else
    {
        _swi1=((!(_tim4O)) && (_gtv3));
    }
    digitalWrite(8, !(_swi1));
    digitalWrite(7, _swi1);
    if ((((((_gtv14) >= (_gtv8)) || ((_gtv15) > (_gtv21)))) || (((!((digitalRead (9)))) || (!(_gtv24))))))
    {
         if (_tim5I) 
        {
             if (_isTimer(_tim5P, 5000)) 
            {
                _tim5O = 1;
            }
        }
         else 
        {
            _tim5I =1;
            _tim5P = millis();
        }
    }
     else 
    {
        _tim5O = 0;
        _tim5I = 0;
    }
    if (_tim5O) 
    {
        if (! _gen1I) 
        {
            _gen1I = 1;
            _gen1O = 1;
            _gen1P =  millis();
        }
    }
     else 
    {
        _gen1I = 0 ;
        _gen1O= 0;
    }
     if (_gen1I) 
    {
         if (_gen1O) 
        {
             if (_isTimer(_gen1P , 200)) 
            {
                 _gen1P = millis();
                _gen1O = 0;
            }
        }
         else  
        {
             if (_isTimer(_gen1P , 400)) 
            {
                  _gen1P = millis();
                _gen1O = 1;
            }
        }
    }
    if(_gen1O)
    {
        if((!_pzs1OES))
        {
             tone(4, 800);
            _pzs1OES =1;
        }
    }
     else 
    {
        if(_pzs1OES)
        {
            noTone(4);
            _pzs1OES =0;
        }
    }
    if(!(_gen1O)) 
    {
        if(! _D1B1)
        {
            _lcd1.backlight();
            _D1B1=1;
        }
    }
     else 
    {
        if(_D1B1)
        {
            _lcd1.noBacklight();
            _D1B1=0;
        }
    }
    if(((!(_gtv25)) && (_gtv24))) 
    {
        _tim3O = 1;
        _tim3I = 1;
    }
     else 
    {
         if(_tim3I) 
        {
            _tim3I = 0;
            _tim3P = millis();
        }
         else 
        {
             if (_tim3O) 
            {
                if (_isTimer(_tim3P, _gtv27)) _tim3O = 0;
            }
        }
    }
    if (_gtv24) 
    {
        _gtv24 = _tim3O;
    }
    if((_gtv14) >= (_gtv19))
    {
        _swi11=(_gtv14) >= (_gtv19);
    }
    else
    {
        _swi11=_gtv29;
    }
    if (_gtv24) 
    {
        _gtv30 = _swi11;
    }
    if(((((!(_gtv25)) && (!((_gtv14) >= (_gtv19))))) && (_gtv20))) 
    {
        _tim1O = 1;
        _tim1I = 1;
    }
     else 
    {
         if(_tim1I) 
        {
            _tim1I = 0;
            _tim1P = millis();
        }
         else 
        {
             if (_tim1O) 
            {
                if (_isTimer(_tim1P, _gtv28)) _tim1O = 0;
            }
        }
    }
    if (_gtv20) 
    {
        _gtv20 = _tim1O;
    }
    if (((((!(_gtv25)) && (!((_gtv14) >= (_gtv19))))) && (_gtv20)))
    {
         if (_tim7I) 
        {
             if (_isTimer(_tim7P, 20000)) 
            {
                _tim7O = 1;
            }
        }
         else 
        {
            _tim7I =1;
            _tim7P = millis();
        }
    }
     else 
    {
        _tim7O = 0;
        _tim7I = 0;
    }
    if (!(_gtv25)) 
    {
        digitalWrite(15, _tim7O);
    }
    digitalWrite(14, _gtv30);
    if (_gtv5 == 1) 
    {
        if (1) 
        {
            _dispTempLength1 = (((((_floatToStringWitRaz(_gtv9,1))) + (String(" ")) + ((_floatToStringWitRaz(_gtv17,1))) + (String(" ")) + ((_floatToStringWitRaz(_gtv14,1)))))).length();
            if (_disp3oldLength > _dispTempLength1) 
            {
                _isNeedClearDisp1 = 1;
            }
            _disp3oldLength = _dispTempLength1;
            _lcd1.setCursor(int((16 - _dispTempLength1)/2), 0);
            _lcd1.print(((((_floatToStringWitRaz(_gtv9,1))) + (String(" ")) + ((_floatToStringWitRaz(_gtv17,1))) + (String(" ")) + ((_floatToStringWitRaz(_gtv14,1))))));
        }
         else 
        {
            if (_disp3oldLength > 0) 
            {
                _isNeedClearDisp1 = 1;
                _disp3oldLength = 0;
            }
        }
        _gtv5 = 0;
    }
    if (_changeNumber6_Out) 
    {
        _changeNumber6_Out = 0;
    }
     else 
    {
        _tempVariable_float = _gtv15;
        if (_tempVariable_float != _changeNumber6_OLV) 
        {
            _changeNumber6_OLV = _tempVariable_float;
            _changeNumber6_Out = 1;
        }
    }
    if (_changeNumber8_Out) 
    {
        _changeNumber8_Out = 0;
    }
     else 
    {
        _tempVariable_int = _gtv2;
        if (_tempVariable_int != _changeNumber8_OLV) 
        {
            _changeNumber8_OLV = _tempVariable_int;
            _changeNumber8_Out = 1;
        }
    }
    if(_BitChange_4_Out) 
    {
        _BitChange_4_Out = 0;
    }
    else
    {
        if(!(_BitChange_4_OldSt == _gtv12))
        {
            _BitChange_4_OldSt = _gtv12;
            _BitChange_4_Out= 1;
        }
    }
    if(_BitChange_1_Out) 
    {
        _BitChange_1_Out = 0;
    }
    else
    {
        if(!(_BitChange_1_OldSt == _gtv33))
        {
            _BitChange_1_OldSt = _gtv33;
            _BitChange_1_Out= 1;
        }
    }
    if(((((_changeNumber6_Out) || (_changeNumber8_Out))) || (((_BitChange_4_Out) || (_BitChange_1_Out))))) 
    {
        _tim6O = 1;
        _tim6I = 1;
    }
     else 
    {
         if(_tim6I) 
        {
            _tim6I = 0;
            _tim6P = millis();
        }
         else 
        {
             if (_tim6O) 
            {
                if (_isTimer(_tim6P, 100)) _tim6O = 0;
            }
        }
    }
    if (_tim6O) 
    {
        _gtv31 = 1;
    }
    if (_gtv33 == 1) 
    {
        if(_gtv12)
        {
            _swi7=String("START");
        }
        else
        {
            _swi7=String("STOP ");
        }
        if (_gtv24) 
        {
            _gtv11 = (((_floatToStringWitRaz((_gtv2)/(10.24),1))) + (String("% ")) + (_swi7) + (String(" ")) + ((_floatToStringWitRaz(_gtv15,0))));
        }
    }
    if (_gtv33 == 0) 
    {
        if((_gtv2) >= (2))
        {
            _swi2=(((_floatToStringWitRaz((_gtv2)/(10.24),1))) + (String("% ")) + (String("Manual ")) + ((_floatToStringWitRaz(_gtv15,0))));
        }
        else
        {
            _swi2=String("HomeSamogon.ru");
        }
        if (_gtv24) 
        {
            _gtv11 = _swi2;
        }
    }
    if (_gtv24 == 0) 
    {
        _gtv2 = 0;
        _gtv3 = 0;
        _gtv4 = 0;
        _gtv20 = 0;
        _gtv30 = 0;
        _gtv33 = 0;
        _gtv8 = 110.00;
        if (!(((String("!STOP AVAR STOP!")).equals(_gtv11)))) 
        {
            _gtv31 = 1;
        }
        if (!(((String("!STOP AVAR STOP!")).equals(_gtv11)))) 
        {
            _gtv11 = String("!STOP AVAR STOP!");
        }
    }
    if (_gtv31 == 1) 
    {
        if (1) 
        {
            _dispTempLength1 = ((_gtv11)).length();
            if (_disp1oldLength > _dispTempLength1) 
            {
                _isNeedClearDisp1 = 1;
            }
            _disp1oldLength = _dispTempLength1;
            _lcd1.setCursor(int((16 - _dispTempLength1)/2), 1);
            _lcd1.print((_gtv11));
        }
         else 
        {
            if (_disp1oldLength > 0) 
            {
                _isNeedClearDisp1 = 1;
                _disp1oldLength = 0;
            }
        }
        _gtv31 = 0;
    }
}
float  _stringToFloat(String value)
{
    return value.toFloat() ;
}
String  _floatToStringWitRaz(float value, int raz)
{
    return String(value,raz);
}
bool _isTimer(unsigned long startTime, unsigned long period)
{
    unsigned long currentTime;
    currentTime = millis();
    if (currentTime>= startTime) 
    {
        return (currentTime>=(startTime + period));
    }
     else 
    {
        return (currentTime >=(4294967295-startTime+period));
    }
}
ISR(TIMER2_OVF_vect)
{
    TCNT2=100;
    if(_PWDC >= 1000)
    {
        asm volatile ("jmp 0x0000");
    }
    else
    {
        _PWDC = _PWDC+1;
    }
    ;
}
void _readByteFromUART(byte data,int port)
{
    if (port==0)
    {
        _RVFU3Data += char(data);
    }
    if (port==100)
    {
        _RVFU1Data += char(data);
    }
}
float _convertDS18x2xData(byte type_s, byte data[12])
{
    int16_t raw = (data[1] << 8) | data[0];
    if (type_s)
    {
        raw = raw << 3;
        if (data[7] == 0x10) 
        {
             raw = (raw & 0xFFF0) + 12 - data[6];
        }
    }
    else
    {
        byte cfg = (data[4] & 0x60);
        if (cfg == 0x00)raw = raw & ~7;
        else if(cfg == 0x20)raw = raw & ~3;
        else if(cfg == 0x40) raw = raw & ~1;
    }
    return  (float)raw / 16.0;
}
float _readDS18_ow2(byte addr[8], byte type_s)
{
    byte data[12];
    byte i;
    _ow2.reset();
    _ow2.select(addr);
    _ow2.write(0xBE);
    for (i = 0; i < 9; i++) 
    {
         data[i] = _ow2.read();
    }
    _ow2.reset();
    _ow2.select(addr);
    _ow2.write(0x44);
    if (_ow2.crc8(data, 8) != data[8])
    {
        return 501;
    }
    return _convertDS18x2xData(type_s, data);
}
bool _checkFreeLogicBlockOutput(bool inArray[], int inArraySize, bool stArray[], int stArraySize)
{
    int inIndex = 0;
    bool result = 1;
    for (int i = 0; i < stArraySize; i = i + 1)
    {
        if (!(inArray[inIndex] == stArray[i])) 
        {
             result = 0;
        }
        inIndex ++;
        if (inIndex == inArraySize)
        {
            if (result) 
            {
                 return 1;
            }
             else 
            {
                result = 1;
            }
            inIndex = 0;
        }
    }
    return 0;
}
void _func_UB_185384122(struct UB_185384122 *_ubInstans, float ubi_117131038)
{
    float ubo_120270494 = _ubInstans->ubo_120270494;
    bool ubo_13416262 = _ubInstans->ubo_13416262;
    float _gtv1 = _ubInstans->_gtv1;
    float _gtv2 = _ubInstans->_gtv2;
    ubo_120270494 = ubi_117131038;
    ubo_13416262 = (((_gtv1) < (ubi_117131038)) && ((ubi_117131038) < (_gtv2)));
    _ubInstans->ubo_120270494 = ubo_120270494;
    _ubInstans->ubo_13416262 = ubo_13416262;
    _ubInstans->_gtv1 = _gtv1;
    _ubInstans->_gtv2 = _gtv2;
}
